;;; eev2-all.el -- load all the rewritten modules of eev.
;;; VERY EXPERIMENTAL! Don't use yet!

;; Copyright (C) 2012 Free Software Foundation, Inc.
;;
;; This file is part of GNU eev.
;;
;; GNU eev is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; GNU eev is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to the
;; Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.
;;
;; Author:     Eduardo Ochs <eduardoochs@gmail.com>
;; Maintainer: Eduardo Ochs <eduardoochs@gmail.com>
;; Version:    2012sep22
;; Keywords:   e-scripts
;;
;; Latest version: <http://angg.twu.net/eev-current/eev2-all.el>
;;       htmlized: <http://angg.twu.net/eev-current/eev2-all.el.html>
;;       See also: <http://angg.twu.net/eev-current/README.html>

;;; Commentary:

;; Just as eev-all.el loads all modules of the stable version of eev
;; (0.95.2) this loads all the refactored modules of eev, that are
;; going to become eev-0.96 - a major rewrite.

;; (setq last-kbd-macro (kbd "C-a M-f 2*<right> C-SPC C-e <left> M-w M-; SPC (find-eev SPC \" C-y\n .el\") C-a <down>"))


;; The main documentation for eev-0.96 is all in the sandboxed
;; "intros" in eev-intro.el


;; (find-eev-intro)


;; The main "killer feature" of eev: eepitch.
;; It is described here: (find-eepitch-intro)
(require 'eepitch)             ; (find-eev "eepitch.el")
(require 'eev-wrap)	       ; (find-eev "eev-wrap.el")

;; The other main killer feature: elisp hyperlinks.
;;
;; The main way to follow hyperlinks (`M-e') and to go back (`M-k')
;; is described in:
;;   (find-eval-intro)
(require 'eev-flash)	       ; (find-eev "eev-flash.el")
(require 'eev-eval)	       ; (find-eev "eev-eval.el")
(require 'eev-multiwindow)     ; (find-eev "eev-multiwindow.el")
(require 'eev-mode)	       ; (find-eev "eev-mode.el")
;;
;; The implementation of hyperlink functions
;; is described in:
;;   (find-links-intro)
(require 'eev-blinks)	       ; (find-eev "eev-blinks.el")
(require 'eev-plinks)	       ; (find-eev "eev-plinks.el")
(require 'eev-elinks)	       ; (find-eev "eev-elinks.el")
(require 'eev-tlinks)	       ; (find-eev "eev-tlinks.el")
;;
;; The ways to mass-produce hyperlink functions
;; are described in:
;;   (find-code-c-d-intro "\nShorter hyperlinks\n")
(require 'eev-code)	       ; (find-eev "eev-code.el")
(require 'eev-env)	       ; (find-eev "eev-env.el")
(require 'eev-brxxx)	       ; (find-eev "eev-brxxx.el")
(require 'eev-pdflike)	       ; (find-eev "eev-pdflike.el")
(require 'eev-audiovideo)      ; (find-eev "eev-audiovideo.el")
(require 'eev-anchors)	       ; (find-eev "eev-anchors.el")

;; User stuff:
(require 'eev-intro)	       ; (find-eev "eev-intro.el")
(require 'eev-edit)            ; (find-eev "eev-edit.el")
(require 'eejump)              ; (find-eev "eejump.el")

;; Advanced (and hard to use) features that may require creating a
;; temporary directory, patching rcfiles, and installing Expect
;; scripts:
(require 'eev-prepared)		; (find-eev "eev-prepared.el")
(require 'eev-bounded)		; (find-eev "eev-bounded.el")
(require 'eev-channels)		; (find-eev "eev-channels.el")


;; Obsolete - this has become "eev-tlinks":
;; (require 'eev-template)      ; (find-eev "eev-template.el")


;; (require 'eev)                 ; (find-eev "eev.el")
;; (require 'eev-bounded)         ; (find-eev "eev-bounded.el")
;; (require 'eev-insert)          ; (find-eev "eev-insert.el")
;; (require 'eev-steps)           ; (find-eev "eev-steps.el")
;; (require 'eev-glyphs)          ; (find-eev "eev-glyphs.el")
;; (require 'eev-compose)         ; (find-eev "eev-compose.el")
;; (require 'eev-langs)           ; (find-eev "eev-langs.el")
;; (require 'eev-browse-url)      ; (find-eev "eev-browse-url.el")

;; These are the only global settings that eev does that can be
;; considered invasive in some sense - `eev-set-aliases' defines some
;; functions that do not start with reserved prefixes `find-', `ee',
;; and `code-'; and `eev-set-default-glyphs' make some changed in the
;; standard display table (oops, TODO: I forgot to mention the
;; `setenv's!... =/).
;;
;; (eev-set-aliases)	       ; (find-eev "eev.el" "eev-set-aliases")
;; (eev-set-default-glyphs)    ; (find-efunction 'eev-set-default-glyphs)

(provide 'eev2-all)




;; Obsolete comments, to be deleted at some point...

;; This is temporary - some of the stepper functions have been
;; rewritten and the new code (in eev-mini-steps.el) is currently much
;; better than the (slightly) more documented code in eev-steps.el...
;; In a near future the rewrites will be migrated to eev-steps and
;; this won't be necessary anymore.
;;
;; (require 'eev-mini-steps)   ; (find-eev "eev-mini-steps.el")
;; (require 'eechannel)        ; (find-eev "eechannel.el")

;; (2008oct15) this is a trick to make the info docs for eev available
;; without having to install them globally...
;; (if (not (boundp 'Info-additional-directory-list))
;;     (setq Info-additional-directory-list nil))
;; (add-to-list 'Info-additional-directory-list (ee-eevfile "doc"))
;; (find-node "(eev)Top")

;; (eev-mode 1)		       ; (find-efunctiondescr 'eev-mode)


;; Local Variables:
;; coding:            raw-text-unix
;; no-byte-compile:   t
;; End:
